Package com.io7m.waxmill.machines

# Class WXMDeviceFramebuffer

java.lang.Object
com.io7m.waxmill.machines.WXMDeviceFramebuffer

All Implemented Interfaces:
  `WXMDeviceType`, `WXMDeviceType.WXMDeviceFramebufferType`

    public final class WXMDeviceFramebuffer
    extends java.lang.Object
    implements WXMDeviceType.WXMDeviceFramebufferType

A raw framebuffer device attached to a VNC server.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXMDeviceFramebuffer.Builder` | Builds instances of type `WXMDeviceFramebuffer`.

  ## Nested classes/interfaces inherited from interface com.io7m.waxmill.machines.WXMDeviceType

  `WXMDeviceType.Kind, WXMDeviceType.WXMDeviceAHCIDiskType, WXMDeviceType.WXMDeviceAHCIOpticalDiskType, WXMDeviceType.WXMDeviceE1000Type, WXMDeviceType.WXMDeviceFramebufferType, WXMDeviceType.WXMDeviceHostBridgeType, WXMDeviceType.WXMDeviceLPCType, WXMDeviceType.WXMDevicePassthruType, WXMDeviceType.WXMDeviceVirtioBlockStorageType, WXMDeviceType.WXMDeviceVirtioNetworkType, WXMDeviceType.WXMLPCTTYNames, WXMDeviceType.WXMNetworkDeviceBackendType, WXMDeviceType.WXMSectorSizesType, WXMDeviceType.WXMStorageBackendFileType, WXMDeviceType.WXMStorageBackendType, WXMDeviceType.WXMStorageBackendZFSVolumeType, WXMDeviceType.WXMTapType, WXMDeviceType.WXMTTYBackendFileType, WXMDeviceType.WXMTTYBackendNMDMType, WXMDeviceType.WXMTTYBackendStdioType, WXMDeviceType.WXMTTYBackendType, WXMDeviceType.WXMVMNetType`

  ## Nested classes/interfaces inherited from interface com.io7m.waxmill.machines.WXMDeviceType.WXMDeviceFramebufferType

  `WXMDeviceType.WXMDeviceFramebufferType.WXMVGAConfiguration`

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXMDeviceFramebuffer.Builder` | `builder()` | Creates a builder for `WXMDeviceFramebuffer`.
  `java.lang.String` | `comment()` |
  `static WXMDeviceFramebuffer` | `copyOf​(WXMDeviceType.WXMDeviceFramebufferType instance)` | Creates an immutable copy of a `WXMDeviceType.WXMDeviceFramebufferType` value.
  `WXMDeviceSlot` | `deviceSlot()` |
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXMDeviceFramebuffer` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `comment`, `deviceSlot`, `listenAddress`, `listenPort`, `width`, `height`, `vgaConfiguration`, `waitForVNC`.
  `int` | `height()` |
  `java.net.InetAddress` | `listenAddress()` |
  `int` | `listenPort()` |
  `java.lang.String` | `toString()` | Prints the immutable value `WXMDeviceFramebuffer` with attribute values.
  `WXMDeviceType.WXMDeviceFramebufferType.WXMVGAConfiguration` | `vgaConfiguration()` |
  `boolean` | `waitForVNC()` |
  `int` | `width()` |
  `WXMDeviceFramebuffer` | `withComment​(java.lang.String value)` | Copy the current immutable object by setting a value for the `comment` attribute.
  `WXMDeviceFramebuffer` | `withDeviceSlot​(WXMDeviceSlot value)` | Copy the current immutable object by setting a value for the `deviceSlot` attribute.
  `WXMDeviceFramebuffer` | `withHeight​(int value)` | Copy the current immutable object by setting a value for the `height` attribute.
  `WXMDeviceFramebuffer` | `withListenAddress​(java.net.InetAddress value)` | Copy the current immutable object by setting a value for the `listenAddress` attribute.
  `WXMDeviceFramebuffer` | `withListenPort​(int value)` | Copy the current immutable object by setting a value for the `listenPort` attribute.
  `WXMDeviceFramebuffer` | `withVgaConfiguration​(WXMDeviceType.WXMDeviceFramebufferType.WXMVGAConfiguration value)` | Copy the current immutable object by setting a value for the `vgaConfiguration` attribute.
  `WXMDeviceFramebuffer` | `withWaitForVNC​(boolean value)` | Copy the current immutable object by setting a value for the `waitForVNC` attribute.
  `WXMDeviceFramebuffer` | `withWidth​(int value)` | Copy the current immutable object by setting a value for the `width` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMDeviceType

  `isConsoleDevice, isStorageDevice`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMDeviceType.WXMDeviceFramebufferType

  `externalName, kind`

- ## Method Details

  - ### comment

    public java.lang.String comment()
    Specified by:
      `comment` in interface `WXMDeviceType`
    Specified by:
      `comment` in interface `WXMDeviceType.WXMDeviceFramebufferType`
    Returns:
      The value of the `comment` attribute

  - ### deviceSlot

    public WXMDeviceSlot deviceSlot()
    Specified by:
      `deviceSlot` in interface `WXMDeviceType`
    Specified by:
      `deviceSlot` in interface `WXMDeviceType.WXMDeviceFramebufferType`
    Returns:
      The value of the `deviceSlot` attribute

  - ### listenAddress

    public java.net.InetAddress listenAddress()
    Specified by:
      `listenAddress` in interface `WXMDeviceType.WXMDeviceFramebufferType`
    Returns:
      The IP address upon which the VNC server will listen

  - ### listenPort

    public int listenPort()
    Specified by:
      `listenPort` in interface `WXMDeviceType.WXMDeviceFramebufferType`
    Returns:
      The port upon which the VNC server will listen

  - ### width

    public int width()
    Specified by:
      `width` in interface `WXMDeviceType.WXMDeviceFramebufferType`
    Returns:
      The width of the framebuffer

  - ### height

    public int height()
    Specified by:
      `height` in interface `WXMDeviceType.WXMDeviceFramebufferType`
    Returns:
      The height of the framebuffer

  - ### vgaConfiguration

    public WXMDeviceType.WXMDeviceFramebufferType.WXMVGAConfiguration vgaConfiguration()
    Specified by:
      `vgaConfiguration` in interface `WXMDeviceType.WXMDeviceFramebufferType`
    Returns:
      The guest VGA configuration used

  - ### waitForVNC

    public boolean waitForVNC()
    Specified by:
      `waitForVNC` in interface `WXMDeviceType.WXMDeviceFramebufferType`
    Returns:
      Delay booting until a VNC connection has arrived

  - ### withComment

    public final WXMDeviceFramebuffer withComment​(java.lang.String value)
    Copy the current immutable object by setting a value for the `comment` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for comment
    Returns:
      A modified copy of the `this` object

  - ### withDeviceSlot

    public final WXMDeviceFramebuffer withDeviceSlot​(WXMDeviceSlot value)
    Copy the current immutable object by setting a value for the `deviceSlot` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for deviceSlot
    Returns:
      A modified copy of the `this` object

  - ### withListenAddress

    public final WXMDeviceFramebuffer withListenAddress​(java.net.InetAddress value)
    Copy the current immutable object by setting a value for the `listenAddress` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for listenAddress
    Returns:
      A modified copy of the `this` object

  - ### withListenPort

    public final WXMDeviceFramebuffer withListenPort​(int value)
    Copy the current immutable object by setting a value for the `listenPort` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for listenPort
    Returns:
      A modified copy of the `this` object

  - ### withWidth

    public final WXMDeviceFramebuffer withWidth​(int value)
    Copy the current immutable object by setting a value for the `width` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for width
    Returns:
      A modified copy of the `this` object

  - ### withHeight

    public final WXMDeviceFramebuffer withHeight​(int value)
    Copy the current immutable object by setting a value for the `height` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for height
    Returns:
      A modified copy of the `this` object

  - ### withVgaConfiguration

    public final WXMDeviceFramebuffer withVgaConfiguration​(WXMDeviceType.WXMDeviceFramebufferType.WXMVGAConfiguration value)
    Copy the current immutable object by setting a value for the `vgaConfiguration` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for vgaConfiguration
    Returns:
      A modified copy of the `this` object

  - ### withWaitForVNC

    public final WXMDeviceFramebuffer withWaitForVNC​(boolean value)
    Copy the current immutable object by setting a value for the `waitForVNC` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for waitForVNC
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXMDeviceFramebuffer` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `comment`, `deviceSlot`, `listenAddress`, `listenPort`, `width`, `height`, `vgaConfiguration`, `waitForVNC`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXMDeviceFramebuffer` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXMDeviceFramebuffer copyOf​(WXMDeviceType.WXMDeviceFramebufferType instance)
    Creates an immutable copy of a `WXMDeviceType.WXMDeviceFramebufferType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXMDeviceFramebuffer instance

  - ### builder

    public static WXMDeviceFramebuffer.Builder builder()
    Creates a builder for `WXMDeviceFramebuffer`.

         WXMDeviceFramebuffer.builder()
            .setComment(String) // optional comment
            .setDeviceSlot(com.io7m.waxmill.machines.WXMDeviceSlot) // required deviceSlot
            .setListenAddress(java.net.InetAddress) // required listenAddress
            .setListenPort(int) // required listenPort
            .setWidth(int) // optional width
            .setHeight(int) // optional height
            .setVgaConfiguration(com.io7m.waxmill.machines.WXMDeviceType.WXMDeviceFramebufferType.WXMVGAConfiguration) // optional vgaConfiguration
            .setWaitForVNC(boolean) // required waitForVNC
            .build();

    Returns:
      A new WXMDeviceFramebuffer builder